<template>
    <split id="gridexpviewgridexpbar" class="app-grid-exp-bar " v-model="split" mode="horizontal" @on-move-end="onSplitChange">
        <div slot='left'>
           <div class="container-header">
                <div class='search-container'>
                    <i-input :search="true"
                        @on-change="($event) => { this.searchText = $event.target.value; }"
                        @on-search="onSearch">
                    </i-input>
                </div>
           </div>
            <div class='grid-exp-bar-content2'>
                <view_gridexpbar_grid 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context" 
    :isSingleSelect="isSingleSelect"
    :showBusyIndicator="true"
    updateAction=""
    removeAction="Remove"
    loaddraftAction=""
    loadAction=""
    createAction=""
    fetchAction="FetchDefault"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="gridexpbar_grid"  
    ref='gridexpbar_grid' 
    @selectionchange="gridexpbar_grid_selectionchange($event)"  
    @load="gridexpbar_grid_load($event)"  
    @closeview="closeView($event)">
</view_gridexpbar_grid>
            </div>
        </div>
        <div slot='right'>
            <component 
              v-if="selection.view && !Object.is(this.selection.view.viewname, '')" 
              :is="selection.view.viewname"
              class="viewcontainer2"
              :viewDefaultUsage="false"
              :viewdata="JSON.stringify(selection.context)"
              :viewparam="JSON.stringify(selection.viewparam)">
            </component>
        </div>
    </split>
</template>


<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import EMRFODEService from '@/service/emrfode/emrfode-service';
import GridExpViewgridexpbarService from './grid-exp-viewgridexpbar-gridexpbar-service';



@Component({
    components: {
      
    }
})
export default class GridExpViewgridexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof GridExpViewgridexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public getControlType(): string {
        return 'GRIDEXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof GridExpViewgridexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {GridExpViewgridexpbarService}
     * @memberof GridExpViewgridexpbarBase
     */
    public service: GridExpViewgridexpbarService = new GridExpViewgridexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMRFODEService}
     * @memberof GridExpViewgridexpbarBase
     */
    public appEntityService: EMRFODEService = new EMRFODEService({ $store: this.$store });

    /**
     * gridexpbar_grid 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_grid_selectionchange($event: any, $event2?: any) {
        this.gridexpbar_selectionchange($event, 'gridexpbar_grid', $event2);
    }

    /**
     * gridexpbar_grid 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_grid_load($event: any, $event2?: any) {
        this.gridexpbar_load($event, 'gridexpbar_grid', $event2);
    }
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof GridExpViewgridexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 视图唯一标识
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof GridExpViewgridexpbarBase
     */
    public isSingleSelect:boolean = true;

    /**
     * 呈现模式，可选值：horizontal或者vertical
     * 
     * @public
     * @type {(string)}
     * @memberof GridExpViewgridexpbarBase
     */
    public showMode:string ="horizontal";

    /**
     * 控件宽度
     *
     * @type {number}
     * @memberof GridExpViewgridexpbarBase
     */
    public ctrlWidth:number = 500;

    /**
     * 控件高度
     *
     * @type {number}
     * @memberof GridExpViewgridexpbarBase
     */
    public ctrlHeight: number = 0;

    /**
     * 选中数据
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public selection: any = {};

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof GridExpViewgridexpbarBase
     */
    public searchText:string = "";

    /**
     * 分割宽度
     *
     * @type {number}
     * @memberof GridExpViewgridexpbarBase
     */
    public split: number = 0.5;

    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navViewName: string = "emrfodedashboard-view9";

    /**
     * 导航过滤项
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navFilter: string = "";

    /**
     * 导航关系
     *
     * @type {string}
     * @memberof GridExpViewgridexpbarBase
     */
    public navPSDer: string = "";
    
    /**
     * 导航上下文参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public navigateContext:any =null;

    /**
     * 导航视图参数
     *
     * @type {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public navigateParams:any = null; 

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof MOBILEENTITY3Canlen
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


    /**
     * split值变化事件
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public onSplitChange() {
        if(this.split){
          this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split});
        }
    }

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof GridExpViewgridexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof GridExpViewgridexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public created() {
         this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'gridexpbar_grid', action: action, data: data });
            });
        } 
    }

    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public afterMounted(){ 
        if(this.$store.getters.getViewSplit(this.viewUID)){
            this.split = this.$store.getters.getViewSplit(this.viewUID);
        }else{
            let containerWidth:number = (document.getElementById("gridexpviewgridexpbar") as any).offsetWidth;
            let containerHeight:number = (document.getElementById("gridexpviewgridexpbar") as any).offsetHeight;
            if(Object.is(this.showMode,'horizontal')){
                if(this.ctrlWidth){
                    this.split = this.ctrlWidth/containerWidth;
                }
            }else{
                if(this.ctrlHeight){
                    this.split = this.ctrlHeight/containerHeight;
                }
            }
            this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split});
        }  
    }

    /**
     * vue 生命周期
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof GridExpViewgridexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
    * 执行搜索
    *
    * @memberof GridExpViewgridexpbarBase
    */
    public onSearch($event:any) {
        let grid:any = this.$refs.gridexpbar_grid;
        grid.load({ query: this.searchText });
        
    }

    /**
     * gridexpbar的选中数据事件
     * 
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        let tempContext:any = {};
        let tempViewParam:any = {};
        if (args.length === 0) {
            return ;
        }
        const arg:any = args[0];
        if(this.context){
            Object.assign(tempContext,JSON.parse(JSON.stringify(this.context)));
        }
        Object.assign(tempContext,{'emrfode':arg['emrfode']});
        Object.assign(tempContext,{srfparentdename:'EMRFODE',srfparentkey:arg['emrfode']});
        if(this.navFilter && !Object.is(this.navFilter,"")){
            Object.assign(tempViewParam,{[this.navFilter]:arg['emrfode']});
        }
        if(this.navPSDer && !Object.is(this.navPSDer,"")){
            Object.assign(tempViewParam,{[this.navPSDer]:arg['emrfode']});
        }
        if(this.navigateContext && Object.keys(this.navigateContext).length >0){
            let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navigateContext);
            Object.assign(tempContext,_context);
        }
        if(this.navigateParams && Object.keys(this.navigateParams).length >0){
            let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navigateParams);
            Object.assign(tempViewParam,_params);
        }
        this.selection = {};
        Object.assign(this.selection, { view: { viewname: this.navViewName },  context:tempContext,viewparam:tempViewParam });
        this.$emit('selectionchange',args);
        this.$forceUpdate();
    }

    /**
     * gridexpbar的load完成事件
     * 
     * @memberof GridExpViewgridexpbarBase
     */
    public gridexpbar_load(args:any, tag?: string, $event2?: any){
        this.$emit('load',args);
    }
}
</script>

<style lang='less'>
@import './grid-exp-viewgridexpbar-gridexpbar.less';
</style>